<?php

include_once($_SERVER['DOCUMENT_ROOT'].'/webEdition/we/include/we_classes/tools/weToolLookup.class.php');
include_once ('meta.conf.php');

$translate = we_core_Local::addTranslation('apps.xml');
we_core_Local::addTranslation('default.xml', 'wecustomerxmlexchange');

$controller = Zend_Controller_Front::getInstance();
$appName = $controller->getParam('appName');

$_tool = weToolLookup::getToolProperties($appName);

$we_menu_wecustomerxmlexchange['000100']['text'] = we_util_Strings::shortenPath($_tool['text'], 40);
$we_menu_wecustomerxmlexchange['000100']['parent'] = '000000';
$we_menu_wecustomerxmlexchange['000100']['perm'] = '';
$we_menu_wecustomerxmlexchange['000100']['enabled'] = '1';


$we_menu_wecustomerxmlexchange['000500']['text'] = $translate->_('Save');
$we_menu_wecustomerxmlexchange['000500']['parent'] = '000100';
$we_menu_wecustomerxmlexchange['000500']['cmd'] = 'app_' . $appName . '_save';
$we_menu_wecustomerxmlexchange['000500']['perm'] = 'CONFIGURE_APP_WECUSTOMERXMLEXCHANGE || ADMINISTRATOR';
$we_menu_wecustomerxmlexchange['000500']['enabled'] = '1';


$we_menu_wecustomerxmlexchange['000950']['parent'] = '000100'; // separator

$we_menu_wecustomerxmlexchange['001000']['text'] = $translate->_('Close');
$we_menu_wecustomerxmlexchange['001000']['parent'] = '000100';
$we_menu_wecustomerxmlexchange['001000']['cmd'] = 'app_' . $appName . '_exit';
$we_menu_wecustomerxmlexchange['001000']['perm'] = '';
$we_menu_wecustomerxmlexchange['001000']['enabled'] = '1';

$we_menu_wecustomerxmlexchange['003000']['text'] = $translate->_('Help');
$we_menu_wecustomerxmlexchange['003000']['parent'] = '000000';
$we_menu_wecustomerxmlexchange['003000']['perm'] = '';
$we_menu_wecustomerxmlexchange['003000']['enabled'] = '1';

$we_menu_wecustomerxmlexchange['003100']['text'] = $translate->_('Help') . '...';
$we_menu_wecustomerxmlexchange['003100']['parent'] = '003000';
$we_menu_wecustomerxmlexchange['003100']['cmd'] = 'app_' . $appName . '_help';
$we_menu_wecustomerxmlexchange['003100']['perm'] = '';
$we_menu_wecustomerxmlexchange['003100']['enabled'] = '1';

$we_menu_wecustomerxmlexchange['003200']['text'] = $translate->_('Info') . '...';
$we_menu_wecustomerxmlexchange['003200']['parent'] = '003000';
$we_menu_wecustomerxmlexchange['003200']['cmd'] = 'app_' . $appName . '_info';
$we_menu_wecustomerxmlexchange['003200']['perm'] = '';
$we_menu_wecustomerxmlexchange['003200']['enabled'] = '1';

?>