<?php
include_once($_SERVER['DOCUMENT_ROOT'].'/webEdition/we/include/we_inc_min.inc.php');
include_once($_SERVER['DOCUMENT_ROOT'].'/webEdition/we/include/we_modules/object/we_objectFile.inc.php');
if(!isset($appPath)){
	$appPath=dirname(__FILE__);
}
// include autoload function
include_once($_SERVER['DOCUMENT_ROOT'].'/webEdition/lib/we/core/autoload.php');

// include configuration
include_once($appPath.'/conf/meta.conf.php');//ist aber wohl schon geladen, aber in anderem Kontext

function weCustomerXMLexchangeVersion(){
	return '0.1';
}
function weCustomerXMLexchangeCheckForConfiguration($appPath){
	if (!file_exists($appPath.'/configuration.txt')){
		$a=array('Version'=> weCustomerXMLexchangeVersion());
		$weCustomerXMLexchangeConfig = new Zend_Config($a);
		$writer = new Zend_Config_Writer_Array(array('config'   => $weCustomerXMLexchangeConfig,'filename' => $appPath.'/configuration.txt'));
		$writer->write();
	}
}
weCustomerXMLexchangeCheckForConfiguration($appPath);
$weCXMLeConfig = new Zend_Config(require $appPath.'/configuration.txt');

function weCustomerXMLexchangeImport(){
	if(!isset($appPath)){
		$appPath=dirname(__FILE__);
	}
	$weCXMLeConfig = new Zend_Config(require $appPath.'/configuration.txt');
	$log='';
	$log.='Import start: '.date('Y-m-d H:i:s').'; ';
	
	if(file_exists($_SERVER['DOCUMENT_ROOT'].$weCXMLeConfig->ImportFile)){
		$xml = simplexml_load_file($_SERVER['DOCUMENT_ROOT'].$weCXMLeConfig->ImportFile,'SimpleXMLElement', LIBXML_NOCDATA);	
	} else {
		return false;
	}
	$selectoptions=array();
	$xmlhierarchie=array();
	$CustomerDaten=array();
	$i=0;
	foreach ($xml->children() as $second_gen) {
		$second_genName=$second_gen->getName();
		if($weCXMLeConfig->XMLnodeName==$second_genName && count($second_gen->children()) ){
			$Cdaten=array();
			$Odaten=array();
			$foreingKey='';
			$weKey='';
			$usernameKey='';
			$passwordKey='';
			foreach ($second_gen->children() as $third_gen) {
				$third_genName=$third_gen->getName();
				$third_genData = (string) $third_gen;
				if($weCXMLeConfig->nodes->$second_genName->$third_genName->Cfield){
					$Cdaten[$weCXMLeConfig->nodes->$second_genName->$third_genName->Cfield]=array('type'=>$weCXMLeConfig->nodes->$second_genName->$third_genName->type,'data'=> (string) $third_gen);	
				}
				if($weCXMLeConfig->nodes->$second_genName->$third_genName->Ofield){
					$Odaten[$weCXMLeConfig->nodes->$second_genName->$third_genName->Ofield]=array('type'=>$weCXMLeConfig->nodes->$second_genName->$third_genName->type,'data'=> (string) $third_gen);	
				}
				if($weCXMLeConfig->NodeFid==$second_genName.'_'.$third_genName){
					$foreingKey=(string) $third_gen;
				}
				if($weCXMLeConfig->NodeWEid==$second_genName.'_'.$third_genName){
					$weKey=(string) $third_gen;
				}
				if($weCXMLeConfig->NodeUsername==$second_genName.'_'.$third_genName){
					$usernameKey=(string) $third_gen;
				}
				if($weCXMLeConfig->NodePassword==$second_genName.'_'.$third_genName){
					$passwordKey=(string) $third_gen;
				}
			}
			$i++;
			importCustomer($weCXMLeConfig,$Cdaten,$Odaten,$foreingKey,$weKey,$usernameKey,$passwordKey);
		} else {
			
		}
		
		if(count($second_gen->children())){
			foreach ($second_gen->children() as $third_gen) {
				$third_genName=$third_gen->getName();
				if($weCXMLeConfig->XMLnodeName==$third_genName && count($third_gen->children()) ){
					$Cdaten=array();
					$Odaten=array();
					$foreingKey='';
					$weKey='';
					$usernameKey='';
					$passwordKey='';
					foreach ($third_gen->children() as $fourth_gen) {
						$fourth_genName=$fourth_gen->getName();
						$fourth_genData = (string) $fourth_gen;
						if($weCXMLeConfig->nodes->$second_genName->$third_genName->$fourth_genName->Cfield){
							$Cdaten[$weCXMLeConfig->nodes->$second_genName->$third_genName->$fourth_genName->Cfield]=array('type'=>$weCXMLeConfig->nodes->$second_genName->$third_genName->$fourth_genName->type,'data'=> (string) $fourth_gen);	
						}
						if($weCXMLeConfig->nodes->$second_genName->$third_genName->$fourth_genName->Ofield){
							$Odaten[$weCXMLeConfig->nodes->$second_genName->$third_genName->$fourth_genName->Ofield]=array('type'=>$weCXMLeConfig->nodes->$second_genName->$third_genName->$fourth_genName->type,'data'=> (string) $fourth_gen);	
						}
						if($weCXMLeConfig->NodeFid==$second_genName.'_'.$third_genName.'_'.$fourth_genName){
							$foreingKey=(string) $fourth_gen;
						}
						if($weCXMLeConfig->NodeWEid==$second_genName.'_'.$third_genName.'_'.$fourth_genName){
							$weKey=(string) $fourth_gen;
						}
						if($weCXMLeConfig->NodeUsername==$second_genName.'_'.$third_genName.'_'.$fourth_genName){
							$usernameKey=(string) $fourth_gen;
						}
						if($weCXMLeConfig->NodePassword==$second_genName.'_'.$third_genName.'_'.$fourth_genName){
							$passwordKey=(string) $fourth_gen;
						}
					}
					$i++;
					importCustomer($weCXMLeConfig,$Cdaten,$Odaten,$foreingKey,$weKey,$usernameKey,$passwordKey);
				} else {
					
				}
			}
		} else {
				
		}
	}
	if(file_exists($appPath.'/log.txt')){
		$logg=file_get_contents($appPath.'/log.txt');	
	}
	$log.='Import end: '.date('Y-m-d H:i:s').'; imported: '.$i."\n";
	file_put_contents($appPath.'/log.txt',$log.$logg);	
	return true;
}
function importCustomer($weCXMLeConfig,$Cdaten,$Odaten,$foreingKey,$weKey,$usernameKey,$passwordKey){
	include_once(WE_CUSTOMER_MODULE_DIR."weCustomer.php");
	$db = new DB_WE();
	
	//Kunden suchen
	$userID=0;
	if($usernameKey){
		$userID= f('SELECT ID FROM ' . CUSTOMER_TABLE . ' WHERE Username="' . $db->escape($usernameKey) . '"', 'ID', $db);
	}
	if(!$userID && $weKey){
		$userID= f('SELECT ID FROM ' . CUSTOMER_TABLE . ' WHERE ID="' . $db->escape($weKey) . '"', 'ID', $db);
	} else {
		if($weCXMLeConfig->foreignKeyField){
			$userID= f('SELECT ID FROM ' . CUSTOMER_TABLE . ' WHERE '.$weCXMLeConfig->foreignKeyField.'="' . $db->escape($foreingKey) . '"', 'ID', $db);
		}
	}
	$customer = new weCustomer($userID);
	
	foreach ($Cdaten as $Ckey => $Cvalue){
		if ($Cvalue['type']=='text'){
			$customer->$Ckey = $Cvalue['data'];
		}
		if ($Cvalue['type']=='date'){
			$customer->$Ckey = strptime($Cvalue['data'],$weCXMLeConfig->DateFormatImport);
		}
	}
	if(!$userID && $passwordKey==''){
		$customer->Password=uniqid();
	}
	if(!$weKey){//wird oben eventuell überschrieben
		$customer->ID=$userID;
	}
	if(!$userID){
		$customer->ID=$customer->db->getInsertId();
	}
	$customer->save();
	
	//Profil Objekt suchen
	$objectID=0;
	if($weCXMLeConfig->ProfileObjectClass){
		include_once(WE_OBJECT_MODULE_DIR."we_objectFile.inc.php");
		include_once($_SERVER["DOCUMENT_ROOT"] . "/webEdition/we/include/we_tags/" . "we_tag_write.inc.php");
		$objectID=f('SELECT ID FROM ' . OBJECT_FILES_TABLE . ' WHERE TableID="'.$weCXMLeConfig->ProfileObjectClass.'" AND WebUserID="' . $db->escape($customer->ID) . '"', 'ID', $db);
		$profileObj= new we_objectFile();
		if($objectID){
			$profileObj->InitByID($objectID,OBJECT_FILES_TABLE);
		} else {
			$_REQUEST['edit_object']=1;
			$myattribs['type']='object';
			$myattribs['classid']=$weCXMLeConfig->ProfileObjectClass;
			$myattribs['parentid']=$weCXMLeConfig->ProfileObjectDir;
			$myattribs['publish']=1;
			$myattribs['forceedit']=1;
			$myattribs['formname']='myform';
			$myattribs['protected']='false';
			$myattribs['onduplicate']='increment';
			if(isset($weCXMLeConfig->Objectname)){
				$dername= $weCXMLeConfig->Objectname;
				$myattribs['name']=$customer->$dername;
			} else {
				$myattribs['name']=$usernameKey;
			}
			we_tag_write($myattribs, '');
			if(isset($GLOBALS["we_object_write_ok"]) && $GLOBALS["we_object_write_ok"]){	
				$objectID= abs(f("SELECT max(ID) as ID FROM " . OBJECT_FILES_TABLE, "ID", $db));
				$profileObj->InitByID($objectID, OBJECT_FILES_TABLE);
				$profileObj->WebUserID=$customer->ID;
			}
		}
		
		if($objectID){
			foreach ($Odaten as $Okey => $Ovalue){
				$oka= explode('_',$Okey);
				if(isset($oka[0])){unset($oka[0]);}
				$Okey=implode('_',$oka);
				if ($Ovalue['type']=='text'){
					$profileObj->setElement($Okey,$Ovalue['data']);
				}
				if ($Ovalue['type']=='date'){
					$profileObj->setElement($Okey,strptime($Ovalue['data'],$weCXMLeConfig->DateFormatImport));
				}
			}
			$profileObj->we_save();
			$profileObj->we_publish();
		}
	}
	
	//als letztes Statement das den Customer betrifft
	$db->query('UPDATE '.CUSTOMER_TABLE.' SET ModifiedBy=\'external\' WHERE ID='.$customer->ID);
	
}
function weCustomerXMLexchangeExport(){
	include_once(WE_CUSTOMER_MODULE_DIR."weCustomer.php");
	include_once(WE_OBJECT_MODULE_DIR."we_objectFile.inc.php");
	if(!isset($appPath)){
		$appPath=dirname(__FILE__);
	}
	$weCXMLeConfig = new Zend_Config(require $appPath.'/configuration.txt');
	$log='';
	$log.='Export start: '.date('Y-m-d H:i:s').'; ';

	$db = new DB_WE();
	$dbO = new DB_WE();
	
	$derText='<?xml version="1.0" encoding="utf-8"?>'."\n".'<'.$weCXMLeConfig->XMLMainnodeName.'>'."\n";
	$tab="\t";
	$tabb="\t";
	if(isset($weCXMLeConfig->XMLParentnodeName) && $weCXMLeConfig->XMLParentnodeName!=''){
		$derText.=$tab.'<'.$weCXMLeConfig->XMLParentnodeName.'>'."\n";
		$tabb="\t\t";
	}
	$q='SELECT * FROM '. CUSTOMER_TABLE;
	$db->query($q);
	$tab="\t";
	$i=0;
	while ($db->next_record()) {$i++;
		$row = $db->Record;
		$derText.=$tabb.'<'.$weCXMLeConfig->XMLnodeName.'>'."\n";
		foreach ($row as $rk => $rv){
			if(!is_numeric($rk)){
				if($weCXMLeConfig->exportC->$rk){
					$derText.=$tab.$tabb.'<'.$weCXMLeConfig->exportC->$rk.'><![CDATA['.$rv.']]></'.$weCXMLeConfig->exportC->$rk.'>'."\n";
				}
			}	
		}
		if($weCXMLeConfig->ProfileObjectClass){
			$q='SELECT ID FROM '. OBJECT_FILES_TABLE .' WHERE IsFolder=0 AND TableID='.$weCXMLeConfig->ProfileObjectClass.' AND WebUserID='.$row['ID'];
			$objectID= f('SELECT ID FROM '. OBJECT_FILES_TABLE .' WHERE IsFolder=0 AND TableID='.$weCXMLeConfig->ProfileObjectClass.' AND WebUserID='.$row['ID'], 'ID', $dbO);
			if($objectID){
				$profileObj= new we_objectFile();
				$profileObj->InitByID($objectID,OBJECT_FILES_TABLE);
				foreach($weCXMLeConfig->exportO as $Okey => $Oval){
					if($Oval){
						$oka= explode('_',$Okey);
						if(isset($oka[0])){unset($oka[0]);}
						$Okey=implode('_',$oka);
						$derText.=$tab.$tabb.'<'.$Oval.'><![CDATA['.$profileObj->getElement($Okey).']]></'.$Oval.'>'."\n";	
					}
					
				}
				
			}
		} 
		$derText.=$tabb.'</'.$weCXMLeConfig->XMLnodeName.'>'."\n";
	}
	
	if(isset($weCXMLeConfig->XMLParentnodeName) && $weCXMLeConfig->XMLParentnodeName!=''){
		$derText.=$tab.'</'.$weCXMLeConfig->XMLParentnodeName.'>'."\n";
	}
	$derText.='</'.$weCXMLeConfig->XMLMainnodeName.'>'."\n";
	file_put_contents($_SERVER['DOCUMENT_ROOT'].$weCXMLeConfig->ExportFile,$derText);
	if(file_exists($appPath.'/log.txt')){
		$logg=file_get_contents($appPath.'/log.txt');	
	}
	$log.='Export end: '.date('Y-m-d H:i:s').'; exported: '.$i."\n";
	file_put_contents($appPath.'/log.txt',$log.$logg);
	return true;
}

