<?php

include_once ($_SERVER['DOCUMENT_ROOT'] . '/webEdition/lib/we/core/autoload.php');

$isUTF8 = substr($GLOBALS['WE_LANGUAGE'], -5) == 'UTF-8';

$translate = we_core_Local::addTranslation('default.xml', 'wecustomerxmlexchange');

$perm_group_name = "wecustomerxmlexchange";
$perm_group_title[$perm_group_name] = $isUTF8 ? $translate->_('wecustomerxmlexchange') : utf8_decode($translate->_('wecustomerxmlexchange'));

$perm_values[$perm_group_name] = array(
	"USE_APP_WECUSTOMERXMLEXCHANGE","IMPORT_APP_WECUSTOMERXMLEXCHANGE","EXPORT_APP_WECUSTOMERXMLEXCHANGE","CONFIGURE_APP_WECUSTOMERXMLEXCHANGE"
);

$perm_titles[$perm_group_name] = array();

$translated = array(
		$translate->_('The user is allowed to use wecustomerxmlexchange'),
		$translate->_('The user is allowed to import from wecustomerxmlexchange'),
		$translate->_('The user is allowed to export from wecustomerxmlexchange'),
		$translate->_('The user is allowed to configure from wecustomerxmlexchange')
);

foreach ($translated as $i => $value) {
	$perm_titles[$perm_group_name][$perm_values[$perm_group_name][$i]] = $isUTF8 ? $value : utf8_decode($value);
}

$perm_defaults[$perm_group_name] = array(
	"USE_APP_WECUSTOMERXMLEXCHANGE" => 0,"IMPORT_APP_WECUSTOMERXMLEXCHANGE" => 0,"EXPORT_APP_WECUSTOMERXMLEXCHANGE" => 0,"CONFIGURE_APP_WECUSTOMERXMLEXCHANGE" => 0
);

?>