<?php

/**
 * @see we_app_TopFrameView
 */
Zend_Loader::loadClass('we_app_TopFrameView');

/**
 * Base class for TopFrameView 
 * 
 * @category   app
 * @package    app_views
 * @license    http://www.gnu.org/licenses/lgpl-3.0.html  LGPL
 */
class wecustomerxmlexchange_views_TopFrameView extends we_app_TopFrameView {

public function getJSTop()
	{
		$js= parent::getJSTop();
		
		$js .= <<<EOS

/* gentoc */
weEventController.register("import", function(data, sender) {
	// fire home command, because when entry is deleted we can't show it anymore!
	//weCmdController.fire({"cmdName": "app_wetinyforum_home"});
	//self.hot = true;  // reset hot
});

weCmdController.register('import_top', 'app_wecustomerxmlexchange_import', function(cmdObj) {
	we_core_JsonRpc.callMethod(
		cmdObj, 
		'{$this->appDir}/index.php/rpc/index', 
		'{$this->appName}.service.Cmd', 
		'import'
		
	);
	weCmdController.cmdOk(cmdObj);
	
});
weEventController.register("export", function(data, sender) {
	// fire home command, because when entry is deleted we can't show it anymore!
	//weCmdController.fire({"cmdName": "app_wetinyforum_home"});
	//self.hot = true;  // reset hot
});

weCmdController.register('createobjects_top', 'app_wecustomerxmlexchange_export', function(cmdObj) {
	we_core_JsonRpc.callMethod(
		cmdObj, 
		'{$this->appDir}/index.php/rpc/index', 
		'{$this->appName}.service.Cmd', 
		'export'
		
	);
	weCmdController.cmdOk(cmdObj);
	
});
		
EOS;
		return $js;
	}


}
?>