<?php
include_once($_SERVER['DOCUMENT_ROOT'].'/webEdition/we/include/we_inc_min.inc.php');

$appName = Zend_Controller_Front::getInstance()->getParam('appName');
$appPath = Zend_Controller_Front::getInstance()->getParam('appPath');
$pi=pathinfo($_SERVER['PHP_SELF']);
$was= $pi['basename'];

$onBeforeSubmitJS = '';
$translate = we_core_Local::addTranslation('apps.xml');
we_core_Local::addTranslation('default.xml', 'wecustomerxmlexchange');

if($was=='Konfiguration'){
$weCXMLeConfig = new Zend_Config(require $appPath.'/configuration.txt',true);
$activTab = isset($_REQUEST['activTab']) ? ($_REQUEST['activTab']) : 'idFilesAndFormatTab';

$this->inputWidth = 500;
$this->inputWidth2 = 200;

$form = new we_ui_layout_Form(array('name' => 'we_form', 'onsubmit' => 'return false', 'method' => 'post'));



//$form->addHTML(we_ui_layout_Form::hidden('ID', $this->model->ID));
$form->addHTML(we_ui_layout_Form::hidden('ID', $this->model->ID));
$form->addHTML(we_ui_layout_Form::hidden('activTab', $activTab));

$row = new we_ui_layout_HeadlineIconTableRow(array('title' => $translate->_('Import and export files')));


$info = new we_ui_layout_NoteDiv();
$info->setType("info");
$info->setStyle("margin:0px;");
$info->addHTML($translate->_('InfoGeneral'));


// create div for content of FilesAndFormat tab
$FilesAndFormatTab = new we_ui_layout_Div(array('id'=>'idFilesAndFormatTab','style'=>'margin-left:20px;'));
$FilesAndFormatTab->addElement($info);

if($activTab!="idFilesAndFormatTab") {
	$FilesAndFormatTab->setHidden(true);
}

$FilesAndFormatTab->addHTML('<h2>'.$translate->_('Import and export files').'</h2>');
$infoImExportFiles = new we_ui_layout_NoteDiv();
$infoImExportFiles->setType("info");
$infoImExportFiles->addHTML($translate->_('InfoImExportFiles'));
$FilesAndFormatTab->addElement($infoImExportFiles);
$acImportFile = new we_ui_controls_ACFileSelector();
$acImportFile->setButtonText($translate->_('Select'));
$acImportFile->setButtonTitle($translate->_('Select'));
$acImportFile->setOnChange('weEventController.fire("docChanged")');
$acImportFile->setTable('');
$acImportFile->setContentType('');
$acImportFile->setWidth(350);
$IDName='ImportFileID';
$PathName='ImportFilePath';
if(isset($weCXMLeConfig->ImportFile) ){
	$_path=$weCXMLeConfig->ImportFile;
} else {
	$_path = '/';;
}
$IDValue = '0';

$acImportFile->setFolderIdValue($IDValue);
$acImportFile->setFolderPathValue($_path);	
$acImportFile->setFolderPathName($PathName);
$acImportFile->setFolderIdName($IDName);
$ImportFileLabel = new we_ui_controls_Label();
$ImportFileLabel->setText($translate->_('Import XML file'));
$FilesAndFormatTab->addElement($ImportFileLabel);
$FilesAndFormatTab->addElement($acImportFile);

$acExportFile = new we_ui_controls_ACFileSelector();
$acExportFile->setButtonText($translate->_('Select'));
$acExportFile->setButtonTitle($translate->_('Select'));
$acExportFile->setTable('');
$acExportFile->setContentType('');
$acExportFile->setWidth(350);
$IDName='ExportFileID';
$PathName='ExportFilePath';
if(isset($weCXMLeConfig->ExportFile) ){
	$_path=$weCXMLeConfig->ExportFile;
} else {
	$_path = '/';;
}
$IDValue = '0';
$acExportFile->setFolderIdValue($IDValue);
$acExportFile->setFolderPathValue($_path);	
$acExportFile->setFolderPathName($PathName);
$acExportFile->setFolderIdName($IDName);
$ExportFileLabel = new we_ui_controls_Label();
$ExportFileLabel->setText($translate->_('Export XML file'));
$FilesAndFormatTab->addElement($ExportFileLabel);
$FilesAndFormatTab->addElement($acExportFile);

$FilesAndFormatTab->addHTML('<h2>'.$translate->_('XML date format').'</h2>');
$infoDateFormat = new we_ui_layout_NoteDiv();
$infoDateFormat->setType("info");
$infoDateFormat->addHTML($translate->_('InfoDateFormat'));
$FilesAndFormatTab->addElement($infoDateFormat);

$DateFormatImportLabel = new we_ui_controls_Label();
$DateFormatImportLabel->setText($translate->_('Date format import'));
$DateFormatImportLabel->setStyle('display:block');
$DateFormatImport= new we_ui_controls_TextField();
$DateFormatImport->setName('DateFormatImport');
$DateFormatImport->setValue($weCXMLeConfig->get('DateFormatImport',''));
$DateFormatImport->setWidth($this->inputWidth);

$DateFormatExportLabel = new we_ui_controls_Label();
$DateFormatExportLabel->setText($translate->_('Date format export'));
$DateFormatExportLabel->setStyle('display:block');
$DateFormatExport = new we_ui_controls_TextField();
$DateFormatExport->setName('DateFormatExport');
$DateFormatExport->setValue($weCXMLeConfig->get('DateFormatExport',''));
$DateFormatExport->setWidth($this->inputWidth);
$FilesAndFormatTab->addElement($DateFormatImportLabel);
$FilesAndFormatTab->addElement($DateFormatImport);
$FilesAndFormatTab->addElement($DateFormatExportLabel);
$FilesAndFormatTab->addElement($DateFormatExport);


$FilesAndFormatTab->addHTML('<h2>'.$translate->_('XML nodes').'</h2>');
$infoXMLnode = new we_ui_layout_NoteDiv();
$infoXMLnode->setType("info");
$infoXMLnode->addHTML($translate->_('InfoXMLnode'));
$FilesAndFormatTab->addElement($infoXMLnode);

$XMLnodeLabel = new we_ui_controls_Label();
$XMLnodeLabel->setText($translate->_('XML node name'));
$XMLnodeLabel->setStyle('display:block');
$XMLnodeName= new we_ui_controls_TextField();
$XMLnodeName->setName('XMLnodeName');
$XMLnodeName->setValue($weCXMLeConfig->get('XMLnodeName',''));
$XMLnodeName->setWidth($this->inputWidth);

$FilesAndFormatTab->addElement($XMLnodeLabel);
$FilesAndFormatTab->addElement($XMLnodeName);

$XMLParentnodeLabel = new we_ui_controls_Label();
$XMLParentnodeLabel->setText($translate->_('XML parent node name'));
$XMLParentnodeLabel->setStyle('display:block');
$XMLParentnodeName= new we_ui_controls_TextField();
$XMLParentnodeName->setName('XMLParentnodeName');
$XMLParentnodeName->setValue($weCXMLeConfig->get('XMLParentnodeName',''));
$XMLParentnodeName->setWidth($this->inputWidth);
$XMLMainParentnodeLabel = new we_ui_controls_Label();
$XMLMainParentnodeLabel->setText($translate->_('XML main node name'));
$XMLMainParentnodeLabel->setStyle('display:block');
$XMLMainParentnodeName= new we_ui_controls_TextField();
$XMLMainParentnodeName->setName('XMLMainnodeName');
$XMLMainParentnodeName->setValue($weCXMLeConfig->get('XMLMainnodeName',''));
$XMLMainParentnodeName->setWidth($this->inputWidth);

$FilesAndFormatTab->addElement($XMLParentnodeLabel);
$FilesAndFormatTab->addElement($XMLParentnodeName);
$FilesAndFormatTab->addElement($XMLMainParentnodeLabel);
$FilesAndFormatTab->addElement($XMLMainParentnodeName);

$FilesAndFormatTab->addHTML('<h2>'.$translate->_('Profile object class').'</h2>');
$infoProfileObjectClass = new we_ui_layout_NoteDiv();
$infoProfileObjectClass->setType("info");
$infoProfileObjectClass->addHTML($translate->_('InfoProfileObjectClass'));
$FilesAndFormatTab->addElement($infoProfileObjectClass);

$ProfileObjectClassLabel = new we_ui_controls_Label();
$ProfileObjectClassLabel->setText($translate->_('Profile object class'));
$ProfileObjectClassLabel->setStyle('display:block');
$ProfileObjectClass= new we_ui_controls_SelectObjectclass();
$ProfileObjectClass->setName('ProfileObjectClass');
$ProfileObjectClass->setWidth($this->inputWidth);
$ProfileObjectClass->setSelectedValue($weCXMLeConfig->get('ProfileObjectClass','0'));
$FilesAndFormatTab->addElement($ProfileObjectClassLabel);
$FilesAndFormatTab->addElement($ProfileObjectClass);

if(isset($weCXMLeConfig->ProfileObjectClass) && $weCXMLeConfig->ProfileObjectClass){
	$ProfileObjectDirLabel = new we_ui_controls_Label();
	$ProfileObjectDirLabel->setText($translate->_('Profile object folder'));
	$ProfileObjectDirLabel->setStyle('display:block');
	if(isset($weCXMLeConfig->ProfileObjectDir) ){
		$IDValue=$weCXMLeConfig->ProfileObjectDir;
	} else {$IDValue = '0';}
	if ($IDValue == '0') {
		$_path = '/';
	} else {
		$_path = we_util_Path::id2Path($IDValue,OBJECT_FILES_TABLE);
	}
	$IDName='ProfileObjectDirID';
	$PathName='ProfileObjectDirPath';	
	
	$ac = new we_ui_controls_ACFileSelector();
	$ac->setButtonText($translate->_('Select'));
	$ac->setButtonTitle($translate->_('Select'));
	$ac->setFolderIdValue($IDValue);
	$ac->setFolderPathValue($_path);
	$ac->setTable('tblObjectFiles');
	$ac->setContentType('folder');
	$ac->setWidth(350);
	
	$ac->setFolderPathName($PathName);
	$ac->setFolderIdName($IDName);
	$FilesAndFormatTab->addElement($ProfileObjectDirLabel);
	$FilesAndFormatTab->addElement($ac);
	
	$ProfileObjectNameLabel = new we_ui_controls_Label();
	$ProfileObjectNameLabel->setText($translate->_('Customer field name which defines the name of generated profile objects'));
	$ProfileObjectNameLabel->setStyle('display:block');
	$kv= new we_ui_controls_SelectCustomerfield();
	$kv->setName('Objectname');
	$kv->setWidth($this->inputWidth);
	$kv->setSelectedValue($weCXMLeConfig->get('Objectname','0'));
	$FilesAndFormatTab->addElement($ProfileObjectNameLabel);
	$FilesAndFormatTab->addElement($kv);
	
}

$form->addElement($FilesAndFormatTab);


$NodesAndFieldsTab = new we_ui_layout_Div(array('id'=>'idNodesAndFields'));
$NodesAndFieldsTab->setStyle('margin:20px;');

if($activTab!="idNodesAndFields") {
	$NodesAndFieldsTab->setHidden(true);
}
$infoNodesAndFields = new we_ui_layout_NoteDiv();
$infoNodesAndFields->setType("info");
$infoNodesAndFields->addHTML($translate->_('InfoNodesAndFields'));
$NodesAndFieldsTab->addElement($infoNodesAndFields);
//Laden der XML-Dateien
if(isset($weCXMLeConfig->ImportFile) && file_exists($_SERVER['DOCUMENT_ROOT'].$weCXMLeConfig->ImportFile)){
$NodesAndFieldsTab->addHTML('<h2>'.$translate->_('Import').'</h2>');
$infoNodesAndFieldsImport = new we_ui_layout_NoteDiv();
$infoNodesAndFieldsImport->setType("info");
$infoNodesAndFieldsImport->addHTML($translate->_('InfoNodesAndFieldsImport'));
$NodesAndFieldsTab->addElement($infoNodesAndFieldsImport);
	$xml = simplexml_load_file($_SERVER['DOCUMENT_ROOT'].$weCXMLeConfig->ImportFile,'SimpleXMLElement', LIBXML_NOCDATA);

	$selectoptions=array('0'=>'-');
	$xmlhierarchie=array();
	foreach ($xml->children() as $second_gen) {
		$selectoptions[$second_gen->getName()]=$second_gen->getName();
		
		if(count($second_gen->children())){
			foreach ($second_gen->children() as $third_gen) {
				$selectoptions[$third_gen->getName()]='-'.$third_gen->getName();
				if(count($third_gen->children())){
					foreach ($third_gen->children() as $fourth_gen) {
						$selectoptions[$fourth_gen->getName()]='--'.$fourth_gen->getName();
						$xmlhierarchie[$second_gen->getName()][$third_gen->getName()][$fourth_gen->getName()]=$fourth_gen->getName();
					}
				} else {
					$xmlhierarchie[$second_gen->getName()][$third_gen->getName()]=$third_gen->getName();
				}
			}
		} else {
			$xmlhierarchie[$second_gen->getName()]=$second_gen->getName();	
		}
	}
	$testSelect= new we_ui_controls_Select();
	$testSelect->setName('testSelect');
	$testSelect->setWidth('200');
	$testSelect->setOptions($selectoptions);
	$testSelect->setHidden(true);
	$NodesAndFieldsTab->addElement($testSelect);
	$foreignKeyFieldLabel = new we_ui_controls_Label();
	$foreignKeyFieldLabel->setText($translate->_('Foreign key field'));
	$foreignKeyFieldLabel->setStyle('display:block');
	$kv= new we_ui_controls_SelectCustomerfield();
	$kv->setName('foreignKeyField');
	$kv->setWidth($this->inputWidth);
	if(isset($weCXMLeConfig->foreignKeyField)){
		$kv->setSelectedValue($weCXMLeConfig->foreignKeyField);
	}
	$NodesAndFieldsTab->addElement($foreignKeyFieldLabel);
	$NodesAndFieldsTab->addElement($kv);
	$tableNodes = new we_ui_layout_Table();
	$tableNodes->setCellPadding('10');
	$tableNodes->addHTML($translate->_('XML-Node'));
	$tableNodes->nextColumn();
	$tableNodes->addHTML($translate->_('Special field'));
	$tableNodes->nextColumn();
	$tableNodes->addHTML($translate->_('Data type'));
	$tableNodes->nextColumn();
	$tableNodes->addHTML($translate->_('Customer field'));
	$tableNodes->nextColumn();
	$tableNodes->addHTML($translate->_('Object field'));
	foreach ($xmlhierarchie as $keyL2 => $valueL2){
		$tableNodes->nextRow(true);
		$tableNodes->addHTML($keyL2);
		if(!is_array($valueL2)){
			$tableNodes->nextColumn();
			$radioSpecialfieldFid = new we_ui_controls_RadioButton();
			$radioSpecialfieldFid->setValue($keyL2);
			if(isset($weCXMLeConfig->NodeFid) && $weCXMLeConfig->NodeFid==$keyL2){
				$radioSpecialfieldFid->setChecked(true);
			}
			$radioSpecialfieldFid->setName('NodeFid');
			$radioSpecialfieldFid->setLabel($translate->_('foreignID'));
			$radioSpecialfieldFid->setHidden(false);
			$radioSpecialfieldFid->setDisabled(false);
			
			$radioSpecialfieldWEid = new we_ui_controls_RadioButton();
			$radioSpecialfieldWEid->setValue($keyL2);
			if(isset($weCXMLeConfig->NodeWEid) && $weCXMLeConfig->NodeWEid==$keyL2){
				$radioSpecialfieldWEid->setChecked(true);
			}
			$radioSpecialfieldWEid->setName('NodeWEid');
			$radioSpecialfieldWEid->setLabel($translate->_('WEID'));
			$radioSpecialfieldWEid->setHidden(false);
			$radioSpecialfieldWEid->setDisabled(false);
			
			$radioSpecialfieldUsername = new we_ui_controls_RadioButton();
			$radioSpecialfieldUsername->setValue($keyL2);
			if(isset($weCXMLeConfig->NodeUsername) && $weCXMLeConfig->NodeUsername==$keyL2){
				$radioSpecialfieldUsername->setChecked(true);
			}
			$radioSpecialfieldUsername->setName('NodeUsername');
			$radioSpecialfieldUsername->setLabel($translate->_('Username'));
			$radioSpecialfieldUsername->setHidden(false);
			$radioSpecialfieldUsername->setDisabled(false);
			
			$radioSpecialfieldPassword = new we_ui_controls_RadioButton();
			$radioSpecialfieldPassword->setValue($keyL2);
			if(isset($weCXMLeConfig->NodePassword) && $weCXMLeConfig->NodePassword==$keyL2){
				$radioSpecialfieldPassword->setChecked(true);
			}
			$radioSpecialfieldPassword->setName('NodePassword');
			$radioSpecialfieldPassword->setLabel($translate->_('Password'));
			$radioSpecialfieldPassword->setHidden(false);
			$radioSpecialfieldPassword->setDisabled(false);
			
			$tableNodes->addHTML($radioSpecialfieldFid->getHTML().$radioSpecialfieldWEid->getHTML().$radioSpecialfieldUsername->getHTML().$radioSpecialfieldPassword->getHTML());
			$tableNodes->nextColumn();
			$radioTypeT = new we_ui_controls_RadioButton();
			$radioTypeT->setValue('text');
			if(isset($weCXMLeConfig->nodes->$keyL2->type) && $weCXMLeConfig->nodes->$keyL2->type=='text'){
				$radioTypeT->setChecked(true);
			}
			$radioTypeT->setName('nodes['.$keyL2.'][type]');
			$radioTypeT->setLabel($translate->_('Text'));
			$radioTypeT->setHidden(false);
			$radioTypeT->setDisabled(false);
			$radioTypeD = new we_ui_controls_RadioButton();
			$radioTypeD->setValue('date');
			if(isset($weCXMLeConfig->nodes->$keyL2->type) && $weCXMLeConfig->nodes->$keyL2->type=='date'){
				$radioTypeD->setChecked(true);
			}
			$radioTypeD->setName('nodes['.$keyL2.'][type]');
			$radioTypeD->setLabel($translate->_('Date'));
			$radioTypeD->setHidden(false);
			$radioTypeD->setDisabled(false);
			$tableNodes->addHTML($radioTypeT->getHTML().$radioTypeD->getHTML());
			
			$tableNodes->nextColumn();
			$kv= new we_ui_controls_SelectCustomerfield();
			
			$kv->setName('nodes['.$keyL2.'][Cfield]');
			$kv->setWidth($this->inputWidthSmall);
			if(isset($weCXMLeConfig->nodes->$keyL2->Cfield)){
				$kv->setSelectedValue($weCXMLeConfig->nodes->$keyL2->get('Cfield','0'));
			}
			$tableNodes->addElement($kv);
			$tableNodes->nextColumn();
			$ob= new we_ui_controls_SelectObjectfield();
			$ob->setObjectclassid($weCXMLeConfig->get('ProfileObjectClass','0'));
			$ob->setWidth($this->inputWidthSmall);
			$ob->setName('nodes['.$keyL2.'][Ofield]');
			if(isset($weCXMLeConfig->nodes->$keyL2->Ofield)){
				$ob->setSelectedValue($weCXMLeConfig->nodes->$keyL2->get('Ofield','0'));
			}
			$tableNodes->addElement($ob);
			
		} else {
			
			foreach($valueL2 as $keyL3 => $valueL3){
				$tableNodes->nextRow(true);
				$tableNodes->addHTML('&nbsp;-'.$keyL3);
				if(!is_array($valueL3)){
					$tableNodes->nextColumn();
					$radioSpecialfieldFid = new we_ui_controls_RadioButton();
					$radioSpecialfieldFid->setValue($keyL2.'_'.$keyL3);
					if(isset($weCXMLeConfig->NodeFid) && $weCXMLeConfig->NodeFid==$keyL2.'_'.$keyL3){
						$radioSpecialfieldFid->setChecked(true);
					}
					$radioSpecialfieldFid->setName('NodeFid');
					$radioSpecialfieldFid->setLabel($translate->_('foreignID'));
					$radioSpecialfieldFid->setHidden(false);
					$radioSpecialfieldFid->setDisabled(false);
					$radioSpecialfieldWEid = new we_ui_controls_RadioButton();
					$radioSpecialfieldWEid->setValue($keyL2.'_'.$keyL3);
					if(isset($weCXMLeConfig->NodeWEid) && $weCXMLeConfig->NodeWEid==$keyL2.'_'.$keyL3){
						$radioSpecialfieldWEid->setChecked(true);
					}
					$radioSpecialfieldWEid->setName('NodeWEid');
					$radioSpecialfieldWEid->setLabel($translate->_('WEID'));
					$radioSpecialfieldWEid->setHidden(false);
					$radioSpecialfieldWEid->setDisabled(false);
					
					$radioSpecialfieldUsername = new we_ui_controls_RadioButton();
					$radioSpecialfieldUsername->setValue($keyL2.'_'.$keyL3);
					if(isset($weCXMLeConfig->NodeUsername) && $weCXMLeConfig->NodeUsername==$keyL2.'_'.$keyL3){
						$radioSpecialfieldUsername->setChecked(true);
					}
					$radioSpecialfieldUsername->setName('NodeUsername');
					$radioSpecialfieldUsername->setLabel($translate->_('Username'));
					$radioSpecialfieldUsername->setHidden(false);
					$radioSpecialfieldUsername->setDisabled(false);
					
					$radioSpecialfieldPassword = new we_ui_controls_RadioButton();
					$radioSpecialfieldPassword->setValue($keyL2.'_'.$keyL3);
					if(isset($weCXMLeConfig->NodePassword) && $weCXMLeConfig->NodePassword==$keyL2.'_'.$keyL3){
						$radioSpecialfieldPassword->setChecked(true);
					}
					$radioSpecialfieldPassword->setName('NodePassword');
					$radioSpecialfieldPassword->setLabel($translate->_('Password'));
					$radioSpecialfieldPassword->setHidden(false);
					$radioSpecialfieldPassword->setDisabled(false);
					
					$tableNodes->addHTML($radioSpecialfieldFid->getHTML().$radioSpecialfieldWEid->getHTML().$radioSpecialfieldUsername->getHTML().$radioSpecialfieldPassword->getHTML());
					$tableNodes->nextColumn();
					$radioTypeT = new we_ui_controls_RadioButton();
					$radioTypeT->setValue('text');
					if(isset($weCXMLeConfig->nodes->$keyL2->$keyL3->type) && $weCXMLeConfig->nodes->$keyL2->$keyL3->type=='text'){
						$radioTypeT->setChecked(true);
					}
					$radioTypeT->setName('nodes['.$keyL2.']['.$keyL3.'][type]');
					$radioTypeT->setLabel($translate->_('Text'));
					$radioTypeT->setHidden(false);
					$radioTypeT->setDisabled(false);
					$radioTypeD = new we_ui_controls_RadioButton();
					$radioTypeD->setValue('date');
					if(isset($weCXMLeConfig->nodes->$keyL2->$keyL3->type) && $weCXMLeConfig->nodes->$keyL2->$keyL3->type=='date'){
						$radioTypeD->setChecked(true);
					}
					$radioTypeD->setName('nodes['.$keyL2.']['.$keyL3.'][type]');
					$radioTypeD->setLabel($translate->_('Date'));
					$radioTypeD->setHidden(false);
					$radioTypeD->setDisabled(false);
					$tableNodes->addHTML($radioTypeT->getHTML().$radioTypeD->getHTML());
					$tableNodes->nextColumn();
					$kv= new we_ui_controls_SelectCustomerfield();
					
					$kv->setName('nodes['.$keyL2.']['.$keyL3.'][Cfield]');
					$kv->setWidth($this->inputWidthSmall);
					if(isset($weCXMLeConfig->nodes->$keyL2->$keyL3->Ofield)){
						$kv->setSelectedValue($weCXMLeConfig->nodes->$keyL2->$keyL3->get('Cfield','0'));
					}
					$tableNodes->addElement($kv);
					$tableNodes->nextColumn();
					$ob= new we_ui_controls_SelectObjectfield();
					$ob->setObjectclassid($weCXMLeConfig->get('ProfileObjectClass','0'));
					$ob->setWidth($this->inputWidthSmall);
					$ob->setName('nodes['.$keyL2.']['.$keyL3.'][Ofield]');
					if(isset($weCXMLeConfig->nodes->$keyL2->$keyL3->Ofield)){
						$ob->setSelectedValue($weCXMLeConfig->nodes->$keyL2->$keyL3->get('Ofield','0'));
					}
					$tableNodes->addElement($ob);
					
				} else {
					foreach($valueL3 as $keyL4 => $valueL4){
						$tableNodes->nextRow(true);
						$tableNodes->addHTML('&nbsp;&nbsp;--'.$keyL4);
						$tableNodes->nextColumn();
						$radioSpecialfieldFid = new we_ui_controls_RadioButton();
						$radioSpecialfieldFid->setValue($keyL2.'_'.$keyL3.'_'.$keyL4);
						if(isset($weCXMLeConfig->NodeFid) && $weCXMLeConfig->NodeFid==$keyL2.'_'.$keyL3.'_'.$keyL4){
							$radioSpecialfieldFid->setChecked(true);
						}
						$radioSpecialfieldFid->setName('NodeFid');
						$radioSpecialfieldFid->setLabel($translate->_('foreignID'));
						$radioSpecialfieldFid->setHidden(false);
						$radioSpecialfieldFid->setDisabled(false);
						$radioSpecialfieldWEid = new we_ui_controls_RadioButton();
						$radioSpecialfieldWEid->setValue($keyL2.'_'.$keyL3.'_'.$keyL4);
						if(isset($weCXMLeConfig->NodeWEid) && $weCXMLeConfig->NodeWEid==$keyL2.'_'.$keyL3.'_'.$keyL4){
							$radioSpecialfieldWEid->setChecked(true);
						}
						$radioSpecialfieldWEid->setName('NodeWEid');
						$radioSpecialfieldWEid->setLabel($translate->_('WEID'));
						$radioSpecialfieldWEid->setHidden(false);
						$radioSpecialfieldWEid->setDisabled(false);
						
						$radioSpecialfieldUsername = new we_ui_controls_RadioButton();
						$radioSpecialfieldUsername->setValue($keyL2.'_'.$keyL3.'_'.$keyL4);
						if(isset($weCXMLeConfig->NodeUsername) && $weCXMLeConfig->NodeUsername==$keyL2.'_'.$keyL3.'_'.$keyL4){
							$radioSpecialfieldUsername->setChecked(true);
						}
						$radioSpecialfieldUsername->setName('NodeUsername');
						$radioSpecialfieldUsername->setLabel($translate->_('Username'));
						$radioSpecialfieldUsername->setHidden(false);
						$radioSpecialfieldUsername->setDisabled(false);
						
						$radioSpecialfieldPassword = new we_ui_controls_RadioButton();
						$radioSpecialfieldPassword->setValue($keyL2.'_'.$keyL3.'_'.$keyL4);
						if(isset($weCXMLeConfig->NodePassword) && $weCXMLeConfig->NodePassword==$keyL2.'_'.$keyL3.'_'.$keyL4){
							$radioSpecialfieldPassword->setChecked(true);
						}
						$radioSpecialfieldPassword->setName('NodePassword');
						$radioSpecialfieldPassword->setLabel($translate->_('Password'));
						$radioSpecialfieldPassword->setHidden(false);
						$radioSpecialfieldPassword->setDisabled(false);
						
						$tableNodes->addHTML($radioSpecialfieldFid->getHTML().$radioSpecialfieldWEid->getHTML().$radioSpecialfieldUsername->getHTML().$radioSpecialfieldPassword->getHTML());
						$tableNodes->nextColumn();
						$radioTypeT = new we_ui_controls_RadioButton();
						$radioTypeT->setValue('text');
						if(isset($weCXMLeConfig->nodes->$keyL2->$keyL3->$keyL4->type) && $weCXMLeConfig->nodes->$keyL2->$keyL3->$keyL4->type=='text'){
							$radioTypeT->setChecked(true);
						}
						$radioTypeT->setName('nodes['.$keyL2.']['.$keyL3.']['.$keyL4.'][type]');
						$radioTypeT->setLabel($translate->_('Text'));
						$radioTypeT->setHidden(false);
						$radioTypeT->setDisabled(false);
						$radioTypeD = new we_ui_controls_RadioButton();
						$radioTypeD->setValue('date');
						if(isset($weCXMLeConfig->nodes->$keyL2->$keyL3->$keyL4->type) && $weCXMLeConfig->nodes->$keyL2->$keyL3->$keyL4->type=='date'){
							$radioTypeD->setChecked(true);
						}
						$radioTypeD->setName('nodes['.$keyL2.']['.$keyL3.']['.$keyL4.'][type]');
						$radioTypeD->setLabel($translate->_('Date'));
						$radioTypeD->setHidden(false);
						$radioTypeD->setDisabled(false);
						$tableNodes->addHTML($radioTypeT->getHTML().$radioTypeD->getHTML());
						$tableNodes->nextColumn();
						$kv= new we_ui_controls_SelectCustomerfield();
						
						$kv->setName('nodes['.$keyL2.']['.$keyL3.']['.$keyL4.'][Cfield]');
						$kv->setWidth($this->inputWidthSmall);
						if(isset($weCXMLeConfig->nodes->$keyL2->$keyL3->$keyL4->Cfield)){
							$kv->setSelectedValue($weCXMLeConfig->nodes->$keyL2->$keyL3->$keyL4->get('Cfield','0'));
						}
						$tableNodes->addElement($kv);
						$tableNodes->nextColumn();
						$ob= new we_ui_controls_SelectObjectfield();
						$ob->setObjectclassid($weCXMLeConfig->get('ProfileObjectClass','0'));
						$ob->setWidth($this->inputWidthSmall);
						$ob->setName('nodes['.$keyL2.']['.$keyL3.']['.$keyL4.'][Ofield]');
						if(isset($weCXMLeConfig->nodes->$keyL2->$keyL3->$keyL4->Ofield)){
							$ob->setSelectedValue($weCXMLeConfig->nodes->$keyL2->$keyL3->$keyL4->get('Ofield','0'));
						}
						$tableNodes->addElement($ob);
						
					}
				}
				
			}
			
		}
		
		
	}
	$NodesAndFieldsTab->addElement($tableNodes);
	
	$NodesAndFieldsTab->addHTML('<h2>'.$translate->_('Export').'</h2>');
	$infoNodesAndFieldsExport = new we_ui_layout_NoteDiv();
	$infoNodesAndFieldsExport->setType("info");
	$infoNodesAndFieldsExport->addHTML($translate->_('InfoNodesAndFieldsExport'));
	$NodesAndFieldsTab->addElement($infoNodesAndFieldsExport);
	$tableExport = new we_ui_layout_Table();
	$tableExport->setCellPadding('10');
	$tableExport->addHTML($translate->_('Customer/Object field'));
	$tableExport->nextColumn();
	$tableExport->addHTML($translate->_('XML-Node'));
	$tableExport->nextColumn();
	
	$db = new DB_WE();
	$db->query("SHOW FIELDS FROM " . CUSTOMER_TABLE);
	
	while ($db->next_record()) {
		$tableExport->nextRow(true);
		$tableExport->addHTML($translate->_('Customer field').' <strong>'.$db->f("Field").'</strong>');									
		$tableExport->nextColumn();
		$exportSelect= new we_ui_controls_Select();
		$exportSelect->setName('exportC['.$db->f("Field").']');
		$exportSelect->setWidth('200');
		$exportSelect->setOptions($selectoptions);
		if(isset($weCXMLeConfig->exportC)){
			$exportSelect->setSelectedValue($weCXMLeConfig->exportC->get($db->f("Field"),'0'));
		}
		$tableExport->addElement($exportSelect);
	}
	
	$db->query("SHOW FIELDS FROM " .OBJECT_X_TABLE.$weCXMLeConfig->ProfileObjectClass);
	while ($db->next_record()) {
		$tableExport->nextRow(true);
		$tableExport->addHTML($translate->_('Object field').' <strong>'.$db->f("Field").'</strong>');									
		$tableExport->nextColumn();
		$exportSelect= new we_ui_controls_Select();
		$exportSelect->setName('exportO['.$db->f("Field").']');
		$exportSelect->setWidth('200');
		$exportSelect->setOptions($selectoptions);
		if(isset($weCXMLeConfig->exportC)){
			$exportSelect->setSelectedValue($weCXMLeConfig->exportO->get($db->f("Field"),'0'));
		}
		$tableExport->addElement($exportSelect);							
	}
	$NodesAndFieldsTab->addElement($tableExport);

}
$form->addElement($NodesAndFieldsTab);


$newTabText = $translate->_('This is a custom tab. You can either edit it or remove it.');

$newTab = new we_ui_layout_Div(array('id'=>'idNewTab'));
$newTab->setStyle('margin:20px;');
$newTab->addHTML($newTabText);
if($activTab!="idNewTab") {
	$newTab->setHidden(true);
}

$form->addElement($newTab);


$XMLfilesTab = new we_ui_layout_Div(array('id'=>'idXMLfiles'));
$XMLfilesTab->setStyle('margin:20px;');
if($activTab!="idXMLfiles") {
	$XMLfilesTab->setHidden(true);
}
$infoXMLfiles = new we_ui_layout_NoteDiv();
$infoXMLfiles->setType("info");
$infoXMLfiles->addHTML($translate->_('InfoXMLfiles'));
$XMLfilesTab->addElement($infoXMLfiles);

$textareaImportfile=new we_ui_controls_Textarea();
$textareaImportfile->setName('TextImportfile');
if(file_exists($_SERVER['DOCUMENT_ROOT'].$weCXMLeConfig->ImportFile)){
	$derText=file_get_contents($_SERVER['DOCUMENT_ROOT'].$weCXMLeConfig->ImportFile);	
} else {
	$derText='';
}
$textareaImportfile->setText($derText);
$textareaImportfile->setDisabled(false);
$textareaImportfile->setHidden(false); 
$textareaImportfile->setWidth("90%");
$textareaImportfile->setHeight("300");


$textareaExportfile=new we_ui_controls_Textarea();
$textareaExportfile->setName('TextExportfile');
if(file_exists($_SERVER['DOCUMENT_ROOT'].$weCXMLeConfig->ExportFile)){
	$derText=file_get_contents($_SERVER['DOCUMENT_ROOT'].$weCXMLeConfig->ExportFile);	
} else {
	$derText='';
}
$textareaExportfile->setText($derText);
$textareaExportfile->setDisabled(false);
$textareaExportfile->setHidden(false); 
$textareaExportfile->setWidth("90%");
$textareaExportfile->setHeight("300");

$XMLfilesTab->addHTML('<br/>'.$ImportFileLabel->getHTML());
$XMLfilesTab->addElement($textareaImportfile);
$XMLfilesTab->addHTML('<br/>'.$ExportFileLabel->getHTML());
$XMLfilesTab->addElement($textareaExportfile);


} else {// Ende was = Konfiguration
	$activTab = isset($_REQUEST['activTab']) ? ($_REQUEST['activTab']) : 'idLogTab';
	$LogTab = new we_ui_layout_Div(array('id'=>'idLogTab','style'=>'margin-left:20px;'));
	$textareaLogfile=new we_ui_controls_Textarea();
	$textareaLogfile->setName('Logfile');
	if(file_exists($appPath.'/log.txt')){
		$derText=file_get_contents($appPath.'/log.txt');	
	} else {
		$derText='';
	}
	$textareaLogfile->setText($derText);
	$textareaLogfile->setDisabled(false);
	$textareaLogfile->setHidden(false); 
	$textareaLogfile->setWidth("90%");
	$textareaLogfile->setHeight("600");
	$LogTab->addElement($textareaLogfile);
}
$htmlPage = we_ui_layout_HTMLPage::getInstance();


$htmlPage->addJSFile('/webEdition/js/windows.js');
$htmlPage->addJSFile('/webEdition/js/we_showMessage.js');
$htmlPage->addJSFile('/webEdition/js/images.js');
$htmlPage->addJSFile('/webEdition/js/libs/yui/yahoo-min.js');
$htmlPage->addJSFile('/webEdition/js/libs/yui/event-min.js');
$htmlPage->addJSFile('/webEdition/js/libs/yui/connection-min.js');
$htmlPage->addJSFile('/webEdition/js/libs/yui/json-min.js');
$htmlPage->addJSFile('/webEdition/lib/we/core/JsonRpc.js');

$filenameEmptyMessage = we_util_Strings::quoteForJSString($translate->_('The name must not be empty!'), false);
		
$filenameEmptyMessageCall = we_core_MessageReporting::getShowMessageCall(
				$filenameEmptyMessage, 
				we_core_MessageReporting::kMessageWarning
		);
		
$folderNotValidMessage = we_util_Strings::quoteForJSString($translate->_('The folder could not be saved.'), false);
		
$folderNotValidMessageCall = we_core_MessageReporting::getShowMessageCall(
				$folderNotValidMessage, 
				we_core_MessageReporting::kMessageWarning
		);
		

$js = '

function submitForm(target, action, method) {
	var f = self.document.we_form;
	if (target) {
		f.target = target;
	}

	if (action) {
		f.action = action;
	}

	if (method) {
		f.method = method;
	}

	f.submit();
}


/* update id hidden field */
function __updateIdEventHandler__(data, sender) {
	var form = document.we_form;
	form.ID.value = data.model.ID;
}
weEventController.register("save", __updateIdEventHandler__);


weCmdController.register("save_body", "app_'.$appName.'_save", null, self, function(cmdObj) 
{

	var form = document.we_form;
	
	if (form.Text.value === "") {
		'. $filenameEmptyMessageCall . '
		form.Text.focus();
		form.Text.select();
		return false;
	}

	'.$onBeforeSubmitJS.'

	var checkACFields = function() {
		if(YAHOO && YAHOO.autocoml && YAHOO.autocoml.checkACFields()) {
			if(YAHOO.autocoml.checkACFields().running) {
				setTimeout(function(){checkACFields(), 100});
				return false;
			}
			else {
				if(YAHOO.autocoml.checkACFields().valid==false) {
					'. $folderNotValidMessageCall . '
					return false;
				}
			}
		}	
		return true;
	}
		
	var acChecked = checkACFields();
	
	if(false===acChecked) {
		return acChecked;
	}

	
	return true;
});

YAHOO.util.Event.addListener(window, "unload", function(e){
	weCmdController.unregister("save_body");
	weEventController.unregister("save", __updateIdEventHandler__);
}); 

';
if($was=='Konfiguration'){
	$htmlPage->addElement($form);
	$htmlPage->addElement($XMLfilesTab);
} else {
	$htmlPage->addElement($LogTab);
}
$htmlPage->addInlineJS($js);
$htmlPage->setBodyAttributes(array('class' => 'weEditorBody', 'onLoad' => 'loaded=1;'));
$htmlPage->addJSFile('/webEdition/js/we_showMessage.js');

echo $htmlPage->getHTML();


?>